/* cairo-utils.c generated by valac 0.20.1, the Vala compiler
 * generated from cairo-utils.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2013 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Marco Trevisan <marco.trevisan@canonical.com>
 *          Mirco "MacSlow" Mueller <mirco.mueller@canonical.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <pixman.h>
#include <gobject/gvaluecollector.h>


#define CAIRO_UTILS_TYPE_GAUSSIAN_BLUR (cairo_utils_gaussian_blur_get_type ())
#define CAIRO_UTILS_GAUSSIAN_BLUR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAIRO_UTILS_TYPE_GAUSSIAN_BLUR, CairoUtilsGaussianBlur))
#define CAIRO_UTILS_GAUSSIAN_BLUR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAIRO_UTILS_TYPE_GAUSSIAN_BLUR, CairoUtilsGaussianBlurClass))
#define CAIRO_UTILS_IS_GAUSSIAN_BLUR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAIRO_UTILS_TYPE_GAUSSIAN_BLUR))
#define CAIRO_UTILS_IS_GAUSSIAN_BLUR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAIRO_UTILS_TYPE_GAUSSIAN_BLUR))
#define CAIRO_UTILS_GAUSSIAN_BLUR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAIRO_UTILS_TYPE_GAUSSIAN_BLUR, CairoUtilsGaussianBlurClass))

typedef struct _CairoUtilsGaussianBlur CairoUtilsGaussianBlur;
typedef struct _CairoUtilsGaussianBlurClass CairoUtilsGaussianBlurClass;
typedef struct _CairoUtilsGaussianBlurPrivate CairoUtilsGaussianBlurPrivate;
#define _pixman_image_unref0(var) ((var == NULL) ? NULL : (var = (pixman_image_unref (var), NULL)))
typedef struct _CairoUtilsParamSpecGaussianBlur CairoUtilsParamSpecGaussianBlur;

#define CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR (cairo_utils_exponential_blur_get_type ())
#define CAIRO_UTILS_EXPONENTIAL_BLUR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR, CairoUtilsExponentialBlur))
#define CAIRO_UTILS_EXPONENTIAL_BLUR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR, CairoUtilsExponentialBlurClass))
#define CAIRO_UTILS_IS_EXPONENTIAL_BLUR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR))
#define CAIRO_UTILS_IS_EXPONENTIAL_BLUR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR))
#define CAIRO_UTILS_EXPONENTIAL_BLUR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR, CairoUtilsExponentialBlurClass))

typedef struct _CairoUtilsExponentialBlur CairoUtilsExponentialBlur;
typedef struct _CairoUtilsExponentialBlurClass CairoUtilsExponentialBlurClass;
typedef struct _CairoUtilsExponentialBlurPrivate CairoUtilsExponentialBlurPrivate;
typedef struct _CairoUtilsParamSpecExponentialBlur CairoUtilsParamSpecExponentialBlur;

struct _CairoUtilsGaussianBlur {
	GTypeInstance parent_instance;
	volatile int ref_count;
	CairoUtilsGaussianBlurPrivate * priv;
};

struct _CairoUtilsGaussianBlurClass {
	GTypeClass parent_class;
	void (*finalize) (CairoUtilsGaussianBlur *self);
};

struct _CairoUtilsParamSpecGaussianBlur {
	GParamSpec parent_instance;
};

struct _CairoUtilsExponentialBlur {
	GTypeInstance parent_instance;
	volatile int ref_count;
	CairoUtilsExponentialBlurPrivate * priv;
};

struct _CairoUtilsExponentialBlurClass {
	GTypeClass parent_class;
	void (*finalize) (CairoUtilsExponentialBlur *self);
};

struct _CairoUtilsParamSpecExponentialBlur {
	GParamSpec parent_instance;
};


static gpointer cairo_utils_gaussian_blur_parent_class = NULL;
static gpointer cairo_utils_exponential_blur_parent_class = NULL;

void cairo_utils_rounded_rectangle (cairo_t* c, gdouble x, gdouble y, gdouble width, gdouble height, gdouble radius);
gpointer cairo_utils_gaussian_blur_ref (gpointer instance);
void cairo_utils_gaussian_blur_unref (gpointer instance);
GParamSpec* cairo_utils_param_spec_gaussian_blur (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void cairo_utils_value_set_gaussian_blur (GValue* value, gpointer v_object);
void cairo_utils_value_take_gaussian_blur (GValue* value, gpointer v_object);
gpointer cairo_utils_value_get_gaussian_blur (const GValue* value);
GType cairo_utils_gaussian_blur_get_type (void) G_GNUC_CONST;
enum  {
	CAIRO_UTILS_GAUSSIAN_BLUR_DUMMY_PROPERTY
};
void cairo_utils_gaussian_blur_surface (cairo_surface_t* surface, guint radius, gdouble sigma);
static pixman_fixed_t* cairo_utils_gaussian_blur_create_gaussian_blur_kernel (gint radius, gdouble sigma, int* result_length1);
CairoUtilsGaussianBlur* cairo_utils_gaussian_blur_new (void);
CairoUtilsGaussianBlur* cairo_utils_gaussian_blur_construct (GType object_type);
static void cairo_utils_gaussian_blur_finalize (CairoUtilsGaussianBlur* obj);
gpointer cairo_utils_exponential_blur_ref (gpointer instance);
void cairo_utils_exponential_blur_unref (gpointer instance);
GParamSpec* cairo_utils_param_spec_exponential_blur (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void cairo_utils_value_set_exponential_blur (GValue* value, gpointer v_object);
void cairo_utils_value_take_exponential_blur (GValue* value, gpointer v_object);
gpointer cairo_utils_value_get_exponential_blur (const GValue* value);
GType cairo_utils_exponential_blur_get_type (void) G_GNUC_CONST;
enum  {
	CAIRO_UTILS_EXPONENTIAL_BLUR_DUMMY_PROPERTY
};
#define CAIRO_UTILS_EXPONENTIAL_BLUR_APREC 16
#define CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC 7
void cairo_utils_exponential_blur_surface (cairo_surface_t* surface, gint radius);
static void cairo_utils_exponential_blur_blur (guchar* pixels, int pixels_length1, gint width, gint height, gint channels, gint radius);
static void cairo_utils_exponential_blur_blurrow (guchar* pixels, int pixels_length1, gint width, gint height, gint channels, gint line, gint alpha);
static void cairo_utils_exponential_blur_blurcol (guchar* pixels, int pixels_length1, gint width, gint height, gint channels, gint x, gint alpha);
static void cairo_utils_exponential_blur_blurinner (guchar* pixel, gint alpha, gint* zR, gint* zG, gint* zB, gint* zA);
CairoUtilsExponentialBlur* cairo_utils_exponential_blur_new (void);
CairoUtilsExponentialBlur* cairo_utils_exponential_blur_construct (GType object_type);
static void cairo_utils_exponential_blur_finalize (CairoUtilsExponentialBlur* obj);


void cairo_utils_rounded_rectangle (cairo_t* c, gdouble x, gdouble y, gdouble width, gdouble height, gdouble radius) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble w;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble h;
	gdouble _tmp4_;
	gdouble kappa;
	cairo_t* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	cairo_t* _tmp9_;
	cairo_t* _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	cairo_t* _tmp15_;
	cairo_t* _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gdouble _tmp20_;
	cairo_t* _tmp21_;
	cairo_t* _tmp22_;
	gdouble _tmp23_;
	gdouble _tmp24_;
	gdouble _tmp25_;
	gdouble _tmp26_;
	cairo_t* _tmp27_;
	cairo_t* _tmp28_;
	gdouble _tmp29_;
	gdouble _tmp30_;
	gdouble _tmp31_;
	gdouble _tmp32_;
	g_return_if_fail (c != NULL);
	_tmp0_ = width;
	_tmp1_ = radius;
	w = _tmp0_ - (_tmp1_ * 2);
	_tmp2_ = height;
	_tmp3_ = radius;
	h = _tmp2_ - (_tmp3_ * 2);
	_tmp4_ = radius;
	kappa = 0.5522847498 * _tmp4_;
	_tmp5_ = c;
	_tmp6_ = x;
	_tmp7_ = radius;
	_tmp8_ = y;
	cairo_move_to (_tmp5_, _tmp6_ + _tmp7_, _tmp8_);
	_tmp9_ = c;
	cairo_rel_line_to (_tmp9_, w, (gdouble) 0);
	_tmp10_ = c;
	_tmp11_ = radius;
	_tmp12_ = radius;
	_tmp13_ = radius;
	_tmp14_ = radius;
	cairo_rel_curve_to (_tmp10_, kappa, (gdouble) 0, _tmp11_, _tmp12_ - kappa, _tmp13_, _tmp14_);
	_tmp15_ = c;
	cairo_rel_line_to (_tmp15_, (gdouble) 0, h);
	_tmp16_ = c;
	_tmp17_ = radius;
	_tmp18_ = radius;
	_tmp19_ = radius;
	_tmp20_ = radius;
	cairo_rel_curve_to (_tmp16_, (gdouble) 0, kappa, kappa - _tmp17_, _tmp18_, -_tmp19_, _tmp20_);
	_tmp21_ = c;
	cairo_rel_line_to (_tmp21_, -w, (gdouble) 0);
	_tmp22_ = c;
	_tmp23_ = radius;
	_tmp24_ = radius;
	_tmp25_ = radius;
	_tmp26_ = radius;
	cairo_rel_curve_to (_tmp22_, -kappa, (gdouble) 0, -_tmp23_, kappa - _tmp24_, -_tmp25_, -_tmp26_);
	_tmp27_ = c;
	cairo_rel_line_to (_tmp27_, (gdouble) 0, -h);
	_tmp28_ = c;
	_tmp29_ = radius;
	_tmp30_ = radius;
	_tmp31_ = radius;
	_tmp32_ = radius;
	cairo_rel_curve_to (_tmp28_, (gdouble) 0, -kappa, _tmp29_ - kappa, -_tmp30_, _tmp31_, -_tmp32_);
}


void cairo_utils_gaussian_blur_surface (cairo_surface_t* surface, guint radius, gdouble sigma) {
	cairo_surface_t* _tmp0_;
	cairo_format_t _tmp1_ = 0;
	cairo_surface_t* _tmp2_;
	guint _tmp3_;
	gdouble _tmp4_ = 0.0;
	gdouble radiusf;
	gdouble _tmp5_;
	cairo_surface_t* _tmp10_;
	gint _tmp11_ = 0;
	gint w;
	cairo_surface_t* _tmp12_;
	gint _tmp13_ = 0;
	gint h;
	cairo_surface_t* _tmp14_;
	gint _tmp15_ = 0;
	gint s;
	cairo_surface_t* _tmp16_;
	guchar* _tmp17_ = NULL;
	guchar* p;
	gint p_length1;
	gint _p_size_;
	gint _tmp18_;
	gint _tmp19_;
	guchar* _tmp20_;
	gint _tmp20__length1;
	gint _tmp21_;
	pixman_image_t* _tmp22_;
	pixman_image_t* src;
	guint _tmp23_;
	gdouble _tmp24_;
	gint _tmp25_ = 0;
	pixman_fixed_t* _tmp26_ = NULL;
	pixman_fixed_t* params;
	gint params_length1;
	gint _params_size_;
	pixman_image_t* _tmp27_;
	pixman_fixed_t* _tmp28_;
	gint _tmp28__length1;
	pixman_image_t* _tmp29_;
	pixman_image_t* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	cairo_surface_t* _tmp33_;
	g_return_if_fail (surface != NULL);
	_tmp0_ = surface;
	_tmp1_ = cairo_image_surface_get_format (_tmp0_);
	if (_tmp1_ != CAIRO_FORMAT_ARGB32) {
		g_warning ("cairo-utils.vala:49: Impossible to blur a non ARGB32-formatted ImageSu" \
"rface");
		return;
	}
	_tmp2_ = surface;
	cairo_surface_flush (_tmp2_);
	_tmp3_ = radius;
	_tmp4_ = fabs ((gdouble) _tmp3_);
	radiusf = _tmp4_ + 1.0f;
	_tmp5_ = sigma;
	if (_tmp5_ == ((gdouble) 0.0f)) {
		gdouble _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_ = 0.0;
		gdouble _tmp9_ = 0.0;
		_tmp6_ = radiusf;
		_tmp7_ = radiusf;
		_tmp8_ = log ((gdouble) (1.0f / 255.0f));
		_tmp9_ = sqrt ((-(_tmp6_ * _tmp7_)) / (2.0f * _tmp8_));
		sigma = _tmp9_;
	}
	_tmp10_ = surface;
	_tmp11_ = cairo_image_surface_get_width (_tmp10_);
	w = _tmp11_;
	_tmp12_ = surface;
	_tmp13_ = cairo_image_surface_get_height (_tmp12_);
	h = _tmp13_;
	_tmp14_ = surface;
	_tmp15_ = cairo_image_surface_get_stride (_tmp14_);
	s = _tmp15_;
	_tmp16_ = surface;
	_tmp17_ = cairo_image_surface_get_data (_tmp16_);
	p = _tmp17_;
	p_length1 = -1;
	_p_size_ = p_length1;
	_tmp18_ = w;
	_tmp19_ = h;
	_tmp20_ = p;
	_tmp20__length1 = p_length1;
	_tmp21_ = s;
	_tmp22_ = pixman_image_create_bits (PIXMAN_a8r8g8b8, _tmp18_, _tmp19_, (uint32_t*) _tmp20_, _tmp21_);
	src = _tmp22_;
	_tmp23_ = radius;
	_tmp24_ = sigma;
	_tmp26_ = cairo_utils_gaussian_blur_create_gaussian_blur_kernel ((gint) _tmp23_, _tmp24_, &_tmp25_);
	params = _tmp26_;
	params_length1 = _tmp25_;
	_params_size_ = params_length1;
	_tmp27_ = src;
	_tmp28_ = params;
	_tmp28__length1 = params_length1;
	pixman_image_set_filter (_tmp27_, PIXMAN_FILTER_CONVOLUTION, _tmp28_, _tmp28__length1);
	_tmp29_ = src;
	_tmp30_ = src;
	_tmp31_ = w;
	_tmp32_ = h;
	pixman_image_composite (PIXMAN_OP_SRC, _tmp29_, NULL, _tmp30_, (gint16) 0, (gint16) 0, (gint16) 0, (gint16) 0, (gint16) 0, (gint16) 0, (guint16) _tmp31_, (guint16) _tmp32_);
	_tmp33_ = surface;
	cairo_surface_mark_dirty (_tmp33_);
	params = (g_free (params), NULL);
	_pixman_image_unref0 (src);
}


static pixman_fixed_t* cairo_utils_gaussian_blur_create_gaussian_blur_kernel (gint radius, gdouble sigma, int* result_length1) {
	pixman_fixed_t* result = NULL;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble scale2;
	gdouble _tmp2_;
	gdouble scale1;
	gint _tmp3_;
	gint size;
	gint _tmp4_;
	gint _tmp5_;
	gint n_params;
	gdouble sum;
	gint _tmp6_;
	gdouble* _tmp7_ = NULL;
	gdouble* tmp;
	gint tmp_length1;
	gint _tmp_size_;
	gint _tmp37_;
	pixman_fixed_t* _tmp38_ = NULL;
	pixman_fixed_t* params;
	gint params_length1;
	gint _params_size_;
	pixman_fixed_t* _tmp39_;
	gint _tmp39__length1;
	gint _tmp40_;
	pixman_fixed_t _tmp41_;
	pixman_fixed_t _tmp42_;
	pixman_fixed_t* _tmp43_;
	gint _tmp43__length1;
	gint _tmp44_;
	pixman_fixed_t _tmp45_;
	pixman_fixed_t _tmp46_;
	pixman_fixed_t* _tmp60_;
	gint _tmp60__length1;
	_tmp0_ = sigma;
	_tmp1_ = sigma;
	scale2 = (2.0f * _tmp0_) * _tmp1_;
	_tmp2_ = scale2;
	scale1 = 1.0f / (G_PI * _tmp2_);
	_tmp3_ = radius;
	size = (2 * _tmp3_) + 1;
	_tmp4_ = size;
	_tmp5_ = size;
	n_params = _tmp4_ * _tmp5_;
	sum = (gdouble) 0;
	_tmp6_ = n_params;
	_tmp7_ = g_new0 (gdouble, _tmp6_);
	tmp = _tmp7_;
	tmp_length1 = _tmp6_;
	_tmp_size_ = tmp_length1;
	{
		gint i;
		gint _tmp8_;
		gint x;
		i = 0;
		_tmp8_ = radius;
		x = -_tmp8_;
		{
			gboolean _tmp9_;
			_tmp9_ = TRUE;
			while (TRUE) {
				gboolean _tmp10_;
				gint _tmp12_;
				gint _tmp13_;
				_tmp10_ = _tmp9_;
				if (!_tmp10_) {
					gint _tmp11_;
					_tmp11_ = x;
					x = _tmp11_ + 1;
				}
				_tmp9_ = FALSE;
				_tmp12_ = x;
				_tmp13_ = radius;
				if (!(_tmp12_ <= _tmp13_)) {
					break;
				}
				{
					gint _tmp14_;
					gint y;
					_tmp14_ = radius;
					y = -_tmp14_;
					{
						gboolean _tmp15_;
						_tmp15_ = TRUE;
						while (TRUE) {
							gboolean _tmp16_;
							gint _tmp19_;
							gint _tmp20_;
							gint _tmp21_;
							gint _tmp22_;
							gdouble u;
							gint _tmp23_;
							gint _tmp24_;
							gdouble v;
							gdouble* _tmp25_;
							gint _tmp25__length1;
							gint _tmp26_;
							gdouble _tmp27_;
							gdouble _tmp28_;
							gdouble _tmp29_;
							gdouble _tmp30_;
							gdouble _tmp31_ = 0.0;
							gdouble _tmp32_;
							gdouble _tmp33_;
							gdouble* _tmp34_;
							gint _tmp34__length1;
							gint _tmp35_;
							gdouble _tmp36_;
							_tmp16_ = _tmp15_;
							if (!_tmp16_) {
								gint _tmp17_;
								gint _tmp18_;
								_tmp17_ = y;
								y = _tmp17_ + 1;
								_tmp18_ = i;
								i = _tmp18_ + 1;
							}
							_tmp15_ = FALSE;
							_tmp19_ = y;
							_tmp20_ = radius;
							if (!(_tmp19_ <= _tmp20_)) {
								break;
							}
							_tmp21_ = x;
							_tmp22_ = x;
							u = (gdouble) (_tmp21_ * _tmp22_);
							_tmp23_ = y;
							_tmp24_ = y;
							v = (gdouble) (_tmp23_ * _tmp24_);
							_tmp25_ = tmp;
							_tmp25__length1 = tmp_length1;
							_tmp26_ = i;
							_tmp27_ = scale1;
							_tmp28_ = u;
							_tmp29_ = v;
							_tmp30_ = scale2;
							_tmp31_ = exp ((-(_tmp28_ + _tmp29_)) / _tmp30_);
							_tmp25_[_tmp26_] = _tmp27_ * _tmp31_;
							_tmp32_ = _tmp25_[_tmp26_];
							_tmp33_ = sum;
							_tmp34_ = tmp;
							_tmp34__length1 = tmp_length1;
							_tmp35_ = i;
							_tmp36_ = _tmp34_[_tmp35_];
							sum = _tmp33_ + _tmp36_;
						}
					}
				}
			}
		}
	}
	_tmp37_ = n_params;
	_tmp38_ = g_new0 (pixman_fixed_t, _tmp37_ + 2);
	params = _tmp38_;
	params_length1 = _tmp37_ + 2;
	_params_size_ = params_length1;
	_tmp39_ = params;
	_tmp39__length1 = params_length1;
	_tmp40_ = size;
	_tmp41_ = pixman_int_to_fixed (_tmp40_);
	_tmp39_[0] = _tmp41_;
	_tmp42_ = _tmp39_[0];
	_tmp43_ = params;
	_tmp43__length1 = params_length1;
	_tmp44_ = size;
	_tmp45_ = pixman_int_to_fixed (_tmp44_);
	_tmp43_[1] = _tmp45_;
	_tmp46_ = _tmp43_[1];
	{
		gint i;
		i = 2;
		{
			gboolean _tmp47_;
			_tmp47_ = TRUE;
			while (TRUE) {
				gboolean _tmp48_;
				gint _tmp50_;
				pixman_fixed_t* _tmp51_;
				gint _tmp51__length1;
				pixman_fixed_t* _tmp52_;
				gint _tmp52__length1;
				gint _tmp53_;
				gdouble* _tmp54_;
				gint _tmp54__length1;
				gint _tmp55_;
				gdouble _tmp56_;
				gdouble _tmp57_;
				pixman_fixed_t _tmp58_;
				pixman_fixed_t _tmp59_;
				_tmp48_ = _tmp47_;
				if (!_tmp48_) {
					gint _tmp49_;
					_tmp49_ = i;
					i = _tmp49_ + 1;
				}
				_tmp47_ = FALSE;
				_tmp50_ = i;
				_tmp51_ = params;
				_tmp51__length1 = params_length1;
				if (!(_tmp50_ < _tmp51__length1)) {
					break;
				}
				_tmp52_ = params;
				_tmp52__length1 = params_length1;
				_tmp53_ = i;
				_tmp54_ = tmp;
				_tmp54__length1 = tmp_length1;
				_tmp55_ = i;
				_tmp56_ = _tmp54_[_tmp55_];
				_tmp57_ = sum;
				_tmp58_ = pixman_double_to_fixed (_tmp56_ / _tmp57_);
				_tmp52_[_tmp53_] = _tmp58_;
				_tmp59_ = _tmp52_[_tmp53_];
			}
		}
	}
	_tmp60_ = params;
	_tmp60__length1 = params_length1;
	if (result_length1) {
		*result_length1 = _tmp60__length1;
	}
	result = _tmp60_;
	tmp = (g_free (tmp), NULL);
	return result;
}


CairoUtilsGaussianBlur* cairo_utils_gaussian_blur_construct (GType object_type) {
	CairoUtilsGaussianBlur* self = NULL;
	self = (CairoUtilsGaussianBlur*) g_type_create_instance (object_type);
	return self;
}


CairoUtilsGaussianBlur* cairo_utils_gaussian_blur_new (void) {
	return cairo_utils_gaussian_blur_construct (CAIRO_UTILS_TYPE_GAUSSIAN_BLUR);
}


static void cairo_utils_value_gaussian_blur_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void cairo_utils_value_gaussian_blur_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		cairo_utils_gaussian_blur_unref (value->data[0].v_pointer);
	}
}


static void cairo_utils_value_gaussian_blur_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = cairo_utils_gaussian_blur_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer cairo_utils_value_gaussian_blur_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* cairo_utils_value_gaussian_blur_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		CairoUtilsGaussianBlur* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = cairo_utils_gaussian_blur_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* cairo_utils_value_gaussian_blur_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	CairoUtilsGaussianBlur** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = cairo_utils_gaussian_blur_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* cairo_utils_param_spec_gaussian_blur (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	CairoUtilsParamSpecGaussianBlur* spec;
	g_return_val_if_fail (g_type_is_a (object_type, CAIRO_UTILS_TYPE_GAUSSIAN_BLUR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer cairo_utils_value_get_gaussian_blur (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CAIRO_UTILS_TYPE_GAUSSIAN_BLUR), NULL);
	return value->data[0].v_pointer;
}


void cairo_utils_value_set_gaussian_blur (GValue* value, gpointer v_object) {
	CairoUtilsGaussianBlur* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CAIRO_UTILS_TYPE_GAUSSIAN_BLUR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CAIRO_UTILS_TYPE_GAUSSIAN_BLUR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		cairo_utils_gaussian_blur_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		cairo_utils_gaussian_blur_unref (old);
	}
}


void cairo_utils_value_take_gaussian_blur (GValue* value, gpointer v_object) {
	CairoUtilsGaussianBlur* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CAIRO_UTILS_TYPE_GAUSSIAN_BLUR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CAIRO_UTILS_TYPE_GAUSSIAN_BLUR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		cairo_utils_gaussian_blur_unref (old);
	}
}


static void cairo_utils_gaussian_blur_class_init (CairoUtilsGaussianBlurClass * klass) {
	cairo_utils_gaussian_blur_parent_class = g_type_class_peek_parent (klass);
	CAIRO_UTILS_GAUSSIAN_BLUR_CLASS (klass)->finalize = cairo_utils_gaussian_blur_finalize;
}


static void cairo_utils_gaussian_blur_instance_init (CairoUtilsGaussianBlur * self) {
	self->ref_count = 1;
}


static void cairo_utils_gaussian_blur_finalize (CairoUtilsGaussianBlur* obj) {
	CairoUtilsGaussianBlur * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAIRO_UTILS_TYPE_GAUSSIAN_BLUR, CairoUtilsGaussianBlur);
}


GType cairo_utils_gaussian_blur_get_type (void) {
	static volatile gsize cairo_utils_gaussian_blur_type_id__volatile = 0;
	if (g_once_init_enter (&cairo_utils_gaussian_blur_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { cairo_utils_value_gaussian_blur_init, cairo_utils_value_gaussian_blur_free_value, cairo_utils_value_gaussian_blur_copy_value, cairo_utils_value_gaussian_blur_peek_pointer, "p", cairo_utils_value_gaussian_blur_collect_value, "p", cairo_utils_value_gaussian_blur_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (CairoUtilsGaussianBlurClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cairo_utils_gaussian_blur_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CairoUtilsGaussianBlur), 0, (GInstanceInitFunc) cairo_utils_gaussian_blur_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType cairo_utils_gaussian_blur_type_id;
		cairo_utils_gaussian_blur_type_id = g_type_register_fundamental (g_type_fundamental_next (), "CairoUtilsGaussianBlur", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&cairo_utils_gaussian_blur_type_id__volatile, cairo_utils_gaussian_blur_type_id);
	}
	return cairo_utils_gaussian_blur_type_id__volatile;
}


gpointer cairo_utils_gaussian_blur_ref (gpointer instance) {
	CairoUtilsGaussianBlur* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void cairo_utils_gaussian_blur_unref (gpointer instance) {
	CairoUtilsGaussianBlur* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		CAIRO_UTILS_GAUSSIAN_BLUR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


void cairo_utils_exponential_blur_surface (cairo_surface_t* surface, gint radius) {
	gint _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp2_;
	guchar* _tmp3_ = NULL;
	guchar* pixels;
	gint pixels_length1;
	gint _pixels_size_;
	cairo_surface_t* _tmp4_;
	gint _tmp5_ = 0;
	gint width;
	cairo_surface_t* _tmp6_;
	gint _tmp7_ = 0;
	gint height;
	cairo_surface_t* _tmp8_;
	cairo_format_t _tmp9_ = 0;
	cairo_format_t format;
	cairo_format_t _tmp10_;
	cairo_surface_t* _tmp23_;
	g_return_if_fail (surface != NULL);
	_tmp0_ = radius;
	if (_tmp0_ < 1) {
		return;
	}
	_tmp1_ = surface;
	cairo_surface_flush (_tmp1_);
	_tmp2_ = surface;
	_tmp3_ = cairo_image_surface_get_data (_tmp2_);
	pixels = _tmp3_;
	pixels_length1 = -1;
	_pixels_size_ = pixels_length1;
	_tmp4_ = surface;
	_tmp5_ = cairo_image_surface_get_width (_tmp4_);
	width = _tmp5_;
	_tmp6_ = surface;
	_tmp7_ = cairo_image_surface_get_height (_tmp6_);
	height = _tmp7_;
	_tmp8_ = surface;
	_tmp9_ = cairo_image_surface_get_format (_tmp8_);
	format = _tmp9_;
	_tmp10_ = format;
	switch (_tmp10_) {
		case CAIRO_FORMAT_ARGB32:
		{
			guchar* _tmp11_;
			gint _tmp11__length1;
			gint _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			_tmp11_ = pixels;
			_tmp11__length1 = pixels_length1;
			_tmp12_ = width;
			_tmp13_ = height;
			_tmp14_ = radius;
			cairo_utils_exponential_blur_blur (_tmp11_, _tmp11__length1, _tmp12_, _tmp13_, 4, _tmp14_);
			break;
		}
		case CAIRO_FORMAT_RGB24:
		{
			guchar* _tmp15_;
			gint _tmp15__length1;
			gint _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			_tmp15_ = pixels;
			_tmp15__length1 = pixels_length1;
			_tmp16_ = width;
			_tmp17_ = height;
			_tmp18_ = radius;
			cairo_utils_exponential_blur_blur (_tmp15_, _tmp15__length1, _tmp16_, _tmp17_, 3, _tmp18_);
			break;
		}
		case CAIRO_FORMAT_A8:
		{
			guchar* _tmp19_;
			gint _tmp19__length1;
			gint _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
			_tmp19_ = pixels;
			_tmp19__length1 = pixels_length1;
			_tmp20_ = width;
			_tmp21_ = height;
			_tmp22_ = radius;
			cairo_utils_exponential_blur_blur (_tmp19_, _tmp19__length1, _tmp20_, _tmp21_, 1, _tmp22_);
			break;
		}
		default:
		{
			break;
		}
	}
	_tmp23_ = surface;
	cairo_surface_mark_dirty (_tmp23_);
}


static void cairo_utils_exponential_blur_blur (guchar* pixels, int pixels_length1, gint width, gint height, gint channels, gint radius) {
	gint _tmp0_;
	gfloat _tmp1_ = 0.0F;
	gint alpha;
	_tmp0_ = radius;
	_tmp1_ = expf ((-2.3f) / (_tmp0_ + 1.0f));
	alpha = (gint) ((1 << CAIRO_UTILS_EXPONENTIAL_BLUR_APREC) * (1.0f - _tmp1_));
	{
		gint row;
		row = 0;
		{
			gboolean _tmp2_;
			_tmp2_ = TRUE;
			while (TRUE) {
				gboolean _tmp3_;
				gint _tmp5_;
				gint _tmp6_;
				guchar* _tmp7_;
				gint _tmp7__length1;
				gint _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				_tmp3_ = _tmp2_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = row;
					row = _tmp4_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp5_ = row;
				_tmp6_ = height;
				if (!(_tmp5_ < _tmp6_)) {
					break;
				}
				_tmp7_ = pixels;
				_tmp7__length1 = pixels_length1;
				_tmp8_ = width;
				_tmp9_ = height;
				_tmp10_ = channels;
				_tmp11_ = row;
				_tmp12_ = alpha;
				cairo_utils_exponential_blur_blurrow (_tmp7_, _tmp7__length1, _tmp8_, _tmp9_, _tmp10_, _tmp11_, _tmp12_);
			}
		}
	}
	{
		gint col;
		col = 0;
		{
			gboolean _tmp13_;
			_tmp13_ = TRUE;
			while (TRUE) {
				gboolean _tmp14_;
				gint _tmp16_;
				gint _tmp17_;
				guchar* _tmp18_;
				gint _tmp18__length1;
				gint _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				gint _tmp23_;
				_tmp14_ = _tmp13_;
				if (!_tmp14_) {
					gint _tmp15_;
					_tmp15_ = col;
					col = _tmp15_ + 1;
				}
				_tmp13_ = FALSE;
				_tmp16_ = col;
				_tmp17_ = width;
				if (!(_tmp16_ < _tmp17_)) {
					break;
				}
				_tmp18_ = pixels;
				_tmp18__length1 = pixels_length1;
				_tmp19_ = width;
				_tmp20_ = height;
				_tmp21_ = channels;
				_tmp22_ = col;
				_tmp23_ = alpha;
				cairo_utils_exponential_blur_blurcol (_tmp18_, _tmp18__length1, _tmp19_, _tmp20_, _tmp21_, _tmp22_, _tmp23_);
			}
		}
	}
}


static void cairo_utils_exponential_blur_blurrow (guchar* pixels, int pixels_length1, gint width, gint height, gint channels, gint line, gint alpha) {
	guchar* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	guchar* scanline;
	guchar* _tmp4_;
	gint zR;
	guchar* _tmp5_;
	gint zG;
	guchar* _tmp6_;
	gint zB;
	guchar* _tmp7_;
	gint zA;
	_tmp0_ = pixels;
	_tmp0__length1 = pixels_length1;
	_tmp1_ = line;
	_tmp2_ = width;
	_tmp3_ = channels;
	scanline = &_tmp0_[(_tmp1_ * _tmp2_) * _tmp3_];
	_tmp4_ = scanline;
	zR = (*_tmp4_) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
	_tmp5_ = scanline;
	zG = (*(_tmp5_ + 1)) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
	_tmp6_ = scanline;
	zB = (*(_tmp6_ + 2)) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
	_tmp7_ = scanline;
	zA = (*(_tmp7_ + 3)) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
	{
		gint index;
		index = 0;
		{
			gboolean _tmp8_;
			_tmp8_ = TRUE;
			while (TRUE) {
				gboolean _tmp9_;
				gint _tmp11_;
				gint _tmp12_;
				guchar* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				_tmp9_ = _tmp8_;
				if (!_tmp9_) {
					gint _tmp10_;
					_tmp10_ = index;
					index = _tmp10_ + 1;
				}
				_tmp8_ = FALSE;
				_tmp11_ = index;
				_tmp12_ = width;
				if (!(_tmp11_ < _tmp12_)) {
					break;
				}
				_tmp13_ = scanline;
				_tmp14_ = index;
				_tmp15_ = channels;
				_tmp16_ = alpha;
				cairo_utils_exponential_blur_blurinner (&_tmp13_[_tmp14_ * _tmp15_], _tmp16_, &zR, &zG, &zB, &zA);
			}
		}
	}
	{
		gint _tmp17_;
		gint index;
		_tmp17_ = width;
		index = _tmp17_ - 2;
		{
			gboolean _tmp18_;
			_tmp18_ = TRUE;
			while (TRUE) {
				gboolean _tmp19_;
				gint _tmp21_;
				guchar* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				_tmp19_ = _tmp18_;
				if (!_tmp19_) {
					gint _tmp20_;
					_tmp20_ = index;
					index = _tmp20_ - 1;
				}
				_tmp18_ = FALSE;
				_tmp21_ = index;
				if (!(_tmp21_ >= 0)) {
					break;
				}
				_tmp22_ = scanline;
				_tmp23_ = index;
				_tmp24_ = channels;
				_tmp25_ = alpha;
				cairo_utils_exponential_blur_blurinner (&_tmp22_[_tmp23_ * _tmp24_], _tmp25_, &zR, &zG, &zB, &zA);
			}
		}
	}
}


static void cairo_utils_exponential_blur_blurcol (guchar* pixels, int pixels_length1, gint width, gint height, gint channels, gint x, gint alpha) {
	guchar* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_;
	gint _tmp2_;
	guchar* ptr;
	guchar* _tmp3_;
	gint zR;
	guchar* _tmp4_;
	gint zG;
	guchar* _tmp5_;
	gint zB;
	guchar* _tmp6_;
	gint zA;
	_tmp0_ = pixels;
	_tmp0__length1 = pixels_length1;
	_tmp1_ = x;
	_tmp2_ = channels;
	ptr = &_tmp0_[_tmp1_ * _tmp2_];
	_tmp3_ = ptr;
	zR = (*_tmp3_) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
	_tmp4_ = ptr;
	zG = (*(_tmp4_ + 1)) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
	_tmp5_ = ptr;
	zB = (*(_tmp5_ + 2)) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
	_tmp6_ = ptr;
	zA = (*(_tmp6_ + 3)) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
	{
		gint _tmp7_;
		gint index;
		_tmp7_ = width;
		index = _tmp7_;
		{
			gboolean _tmp8_;
			_tmp8_ = TRUE;
			while (TRUE) {
				gboolean _tmp9_;
				gint _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				guchar* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				_tmp9_ = _tmp8_;
				if (!_tmp9_) {
					gint _tmp10_;
					gint _tmp11_;
					_tmp10_ = index;
					_tmp11_ = width;
					index = _tmp10_ + _tmp11_;
				}
				_tmp8_ = FALSE;
				_tmp12_ = index;
				_tmp13_ = height;
				_tmp14_ = width;
				if (!(_tmp12_ < ((_tmp13_ - 1) * _tmp14_))) {
					break;
				}
				_tmp15_ = ptr;
				_tmp16_ = index;
				_tmp17_ = channels;
				_tmp18_ = alpha;
				cairo_utils_exponential_blur_blurinner (&_tmp15_[_tmp16_ * _tmp17_], _tmp18_, &zR, &zG, &zB, &zA);
			}
		}
	}
	{
		gint _tmp19_;
		gint _tmp20_;
		gint index;
		_tmp19_ = height;
		_tmp20_ = width;
		index = (_tmp19_ - 2) * _tmp20_;
		{
			gboolean _tmp21_;
			_tmp21_ = TRUE;
			while (TRUE) {
				gboolean _tmp22_;
				gint _tmp25_;
				guchar* _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				_tmp22_ = _tmp21_;
				if (!_tmp22_) {
					gint _tmp23_;
					gint _tmp24_;
					_tmp23_ = index;
					_tmp24_ = width;
					index = _tmp23_ - _tmp24_;
				}
				_tmp21_ = FALSE;
				_tmp25_ = index;
				if (!(_tmp25_ >= 0)) {
					break;
				}
				_tmp26_ = ptr;
				_tmp27_ = index;
				_tmp28_ = channels;
				_tmp29_ = alpha;
				cairo_utils_exponential_blur_blurinner (&_tmp26_[_tmp27_ * _tmp28_], _tmp29_, &zR, &zG, &zB, &zA);
			}
		}
	}
}


static void cairo_utils_exponential_blur_blurinner (guchar* pixel, gint alpha, gint* zR, gint* zG, gint* zB, gint* zA) {
	gint R = 0;
	gint G = 0;
	gint B = 0;
	guchar A = '\0';
	guchar* _tmp0_;
	guchar* _tmp1_;
	guchar* _tmp2_;
	guchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	guchar* _tmp16_;
	gint _tmp17_;
	guchar _tmp18_;
	guchar* _tmp19_;
	gint _tmp20_;
	guchar _tmp21_;
	guchar* _tmp22_;
	gint _tmp23_;
	guchar _tmp24_;
	guchar* _tmp25_;
	gint _tmp26_;
	guchar _tmp27_;
	_tmp0_ = pixel;
	R = (gint) (*_tmp0_);
	_tmp1_ = pixel;
	G = (gint) (*(_tmp1_ + 1));
	_tmp2_ = pixel;
	B = (gint) (*(_tmp2_ + 2));
	_tmp3_ = pixel;
	A = *(_tmp3_ + 3);
	_tmp4_ = *zR;
	_tmp5_ = alpha;
	_tmp6_ = *zR;
	*zR = _tmp4_ + ((_tmp5_ * ((R << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC) - _tmp6_)) >> CAIRO_UTILS_EXPONENTIAL_BLUR_APREC);
	_tmp7_ = *zG;
	_tmp8_ = alpha;
	_tmp9_ = *zG;
	*zG = _tmp7_ + ((_tmp8_ * ((G << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC) - _tmp9_)) >> CAIRO_UTILS_EXPONENTIAL_BLUR_APREC);
	_tmp10_ = *zB;
	_tmp11_ = alpha;
	_tmp12_ = *zB;
	*zB = _tmp10_ + ((_tmp11_ * ((B << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC) - _tmp12_)) >> CAIRO_UTILS_EXPONENTIAL_BLUR_APREC);
	_tmp13_ = *zA;
	_tmp14_ = alpha;
	_tmp15_ = *zA;
	*zA = _tmp13_ + ((_tmp14_ * ((A << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC) - _tmp15_)) >> CAIRO_UTILS_EXPONENTIAL_BLUR_APREC);
	_tmp16_ = pixel;
	_tmp17_ = *zR;
	*_tmp16_ = (guchar) (_tmp17_ >> CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC);
	_tmp18_ = *_tmp16_;
	_tmp19_ = pixel;
	_tmp20_ = *zG;
	*(_tmp19_ + 1) = (guchar) (_tmp20_ >> CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC);
	_tmp21_ = *(_tmp19_ + 1);
	_tmp22_ = pixel;
	_tmp23_ = *zB;
	*(_tmp22_ + 2) = (guchar) (_tmp23_ >> CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC);
	_tmp24_ = *(_tmp22_ + 2);
	_tmp25_ = pixel;
	_tmp26_ = *zA;
	*(_tmp25_ + 3) = (guchar) (_tmp26_ >> CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC);
	_tmp27_ = *(_tmp25_ + 3);
}


CairoUtilsExponentialBlur* cairo_utils_exponential_blur_construct (GType object_type) {
	CairoUtilsExponentialBlur* self = NULL;
	self = (CairoUtilsExponentialBlur*) g_type_create_instance (object_type);
	return self;
}


CairoUtilsExponentialBlur* cairo_utils_exponential_blur_new (void) {
	return cairo_utils_exponential_blur_construct (CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR);
}


static void cairo_utils_value_exponential_blur_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void cairo_utils_value_exponential_blur_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		cairo_utils_exponential_blur_unref (value->data[0].v_pointer);
	}
}


static void cairo_utils_value_exponential_blur_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = cairo_utils_exponential_blur_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer cairo_utils_value_exponential_blur_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* cairo_utils_value_exponential_blur_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		CairoUtilsExponentialBlur* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = cairo_utils_exponential_blur_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* cairo_utils_value_exponential_blur_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	CairoUtilsExponentialBlur** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = cairo_utils_exponential_blur_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* cairo_utils_param_spec_exponential_blur (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	CairoUtilsParamSpecExponentialBlur* spec;
	g_return_val_if_fail (g_type_is_a (object_type, CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer cairo_utils_value_get_exponential_blur (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR), NULL);
	return value->data[0].v_pointer;
}


void cairo_utils_value_set_exponential_blur (GValue* value, gpointer v_object) {
	CairoUtilsExponentialBlur* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		cairo_utils_exponential_blur_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		cairo_utils_exponential_blur_unref (old);
	}
}


void cairo_utils_value_take_exponential_blur (GValue* value, gpointer v_object) {
	CairoUtilsExponentialBlur* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		cairo_utils_exponential_blur_unref (old);
	}
}


static void cairo_utils_exponential_blur_class_init (CairoUtilsExponentialBlurClass * klass) {
	cairo_utils_exponential_blur_parent_class = g_type_class_peek_parent (klass);
	CAIRO_UTILS_EXPONENTIAL_BLUR_CLASS (klass)->finalize = cairo_utils_exponential_blur_finalize;
}


static void cairo_utils_exponential_blur_instance_init (CairoUtilsExponentialBlur * self) {
	self->ref_count = 1;
}


static void cairo_utils_exponential_blur_finalize (CairoUtilsExponentialBlur* obj) {
	CairoUtilsExponentialBlur * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR, CairoUtilsExponentialBlur);
}


GType cairo_utils_exponential_blur_get_type (void) {
	static volatile gsize cairo_utils_exponential_blur_type_id__volatile = 0;
	if (g_once_init_enter (&cairo_utils_exponential_blur_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { cairo_utils_value_exponential_blur_init, cairo_utils_value_exponential_blur_free_value, cairo_utils_value_exponential_blur_copy_value, cairo_utils_value_exponential_blur_peek_pointer, "p", cairo_utils_value_exponential_blur_collect_value, "p", cairo_utils_value_exponential_blur_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (CairoUtilsExponentialBlurClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cairo_utils_exponential_blur_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CairoUtilsExponentialBlur), 0, (GInstanceInitFunc) cairo_utils_exponential_blur_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType cairo_utils_exponential_blur_type_id;
		cairo_utils_exponential_blur_type_id = g_type_register_fundamental (g_type_fundamental_next (), "CairoUtilsExponentialBlur", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&cairo_utils_exponential_blur_type_id__volatile, cairo_utils_exponential_blur_type_id);
	}
	return cairo_utils_exponential_blur_type_id__volatile;
}


gpointer cairo_utils_exponential_blur_ref (gpointer instance) {
	CairoUtilsExponentialBlur* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void cairo_utils_exponential_blur_unref (gpointer instance) {
	CairoUtilsExponentialBlur* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		CAIRO_UTILS_EXPONENTIAL_BLUR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



